Public Class Form1
    ' Evaluate the expression entered by the user.
    Private Sub btnEvaluate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEvaluate.Click
        ' Store the primitives.
        Dim txt_names() As TextBox = {txtName0, txtName1, txtName2, txtName3, txtName4}
        Dim txt_values() As TextBox = {txtValue0, txtValue1, txtValue2, txtValue3, txtValue4}
        Dim primatives As New Dictionary(Of String, Double)
        For i As Integer = 0 To txt_names.Length - 1
            Dim name As String = txt_names(i).Text.Trim()
            Dim value As String = txt_values(i).Text.Trim()
            If (name.Length > 0) AndAlso (value.Length > 0) Then
                primatives.Add(name, CDbl(txt_values(i).Text))
            End If
        Next i

        ' Get the expression.
        Dim expr As String = txtExpression.Text

        ' Evaluate the expression.
        txtResult.Text = ""
        Try
            Dim result As Double = EvaluateExpression(expr, primatives)
            txtResult.Text = Format$(result)
        Catch ex As Exception
            MessageBox.Show("Error calculating expression " & expr & "." & vbCrLf & ex.Message, _
                "Evaluation Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub
End Class
